(*
CMajor AST
by PLT Sandwich
Andrew OReilly, Stephanie Huang
*)

(* All operators. TODO: make sure this is complete *)
type operator =   Add | Sub | Mul | Div | Layer | Arrcat | Rep 
                | Eq | Neq | Gt | Gte | Lt | Lte

(* Variable declaration. See parser for initialization *)
type vdecl = string * string

(* Literal types *)             
type literal = 
    Intlit of int                (* Integers - 42 *)
  | Pitchlit of int * int        (* Pitches - $Cb7 *)
  | Tuple of expr * expr         (* Tuples - notes, durations *)

and expr =
    Binop of expr * operator * expr (* Binary operations *)
  | Noexpr                          (* Empty expression *)
  | Lit of literal                  (* Literals are expressions *)
  | Asn of string * expr            (* Variable assignment *)
  | Id of string                    (* Identifiers *)
  | Call of string * expr list      (* Function call *)
  | Arr of expr list                (* Arrays *)
  | Arrget of string * expr         (* Array reference *)
  | Arrmod of string * expr * expr  (* Array modification *)
  
(* Statements *)
type stmt =
    Block of stmt list
  | Expr of expr
  | Return of expr
  | If of expr * stmt * stmt
  | For of expr * expr * expr * stmt
  | Vdecl of string * string
  | VdeclAsn of stmt * expr
    
(* Function declaration. Args list is now a vdecl list *)
type func_decl = {
  ftype: string;
  fname: string;
  formals: vdecl list;
  locals : string list;
  body: stmt list;
}

(* type program = stmt *)
type program = vdecl list * func_decl list
