(* 
cmajor.ml
Main executable for C-Major
By PLT Sandwich
Andrew OReilly, Stephanie Huang
*)

open Ast
open Sast
open Compile
open Semantics
open Printf

let _ =
  let chan = if Array.length Sys.argv = 2
  then
    try
      Some(open_in Sys.argv.(1))
    with Sys_error(s) ->
      print_endline ("Error: " ^ s); None
  else (
    Some(stdin)
  )
  in match chan with
      Some(channel) ->
        let lexbuf = Lexing.from_channel channel in
        let prog = Parser.program Scanner.token lexbuf in
        Execute.execute_prog prog
    | _ -> exit 1;
